#!/bin/bash

# API token
API_TOKEN=""

DOMAIN=$(expr match "$CERTBOT_DOMAIN" '.*\.\(.*\..*\)')
if [ -z $DOMAIN ]; then
    DOMAIN=$CERTBOT_DOMAIN
else
    SUBDOMAIN=.${CERTBOT_DOMAIN%".$DOMAIN"}
fi

# Create TXT record
DNSURL=`curl -s -X POST "https://api.variomedia.de/dns-records" \
    -H "Authorization: token $API_TOKEN" \
    -H "Content-Type: application/vnd.api+json" \
    -H "Accept: application/vnd.variomedia.v1+json" \
    --data '{"data":{"type":"dns-record","attributes":{"record_type":"TXT","name":"'_acme-challenge${SUBDOMAIN}'","domain":"'$DOMAIN'","data":"'$CERTBOT_VALIDATION'","ttl":300}}}' \
    | jq '.data.links["dns-record"]'`

# Save info for cleanup
if [ ! -d /tmp/CERTBOT_$CERTBOT_DOMAIN ];then
        mkdir -m 0700 /tmp/CERTBOT_$CERTBOT_DOMAIN
fi
echo $DNSURL | sed 's/"//g' >> /tmp/CERTBOT_$CERTBOT_DOMAIN/DNSURL

# Wait for DNS update
for i in {1..7}; do
    sleep 10
    ACMEDNS=`host -t TXT _acme-challenge${SUBDOMAIN}.${DOMAIN}`
    if [[ "$ACMEDNS" =~ "$CERTBOT_VALIDATION" ]]; then
        break;
    fi
done
